## When an item is dropped onto an enchant table
execute as @e[type=item] at @s if block ~ ~ ~ minecraft:enchanting_table align xz positioned ~0.5 ~ ~0.5 run tp @s ~ ~ ~
execute as @e[type=item,tag=!ready] at @s if block ~ ~ ~ minecraft:enchanting_table run playsound minecraft:block.amethyst_block.break ambient @a ~ ~ ~
execute as @e[type=item,tag=!ready] at @s if block ~ ~ ~ minecraft:enchanting_table run tag @s add ready

## Remove the "ready" tag from items that aren't on enchanting tables
execute as @e[type=item,tag=ready] at @s if block ~ ~ ~ minecraft:enchanting_table run tag @s add checkedready
execute as @e[type=item,tag=ready,tag=!checkedready] at @s run tag @s remove ready
tag @e remove checkedready

## Remove glowing from all items, and give ready items glowing
execute as @e[type=minecraft:item,tag=!ready] run data merge entity @s {Glowing:0}
execute as @e[type=minecraft:item,tag=ready] run data merge entity @s {Glowing:1}

## Crafting reset
scoreboard players set MythicStaffs mythicstaffs.crafting.1 0
scoreboard players set MythicStaffs mythicstaffs.crafting.2 0
scoreboard players set MythicStaffs mythicstaffs.crafting.3 0

## Crafting check
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:stick",components:{"minecraft:custom_model_data":1}}}] run scoreboard players set MythicStaffs mythicstaffs.crafting.1 1
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:command_block",components:{"minecraft:custom_model_data":1}}}] run scoreboard players set MythicStaffs mythicstaffs.crafting.2 1
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:flint",components:{"minecraft:custom_model_data":1}}}] run scoreboard players set MythicStaffs mythicstaffs.crafting.3 1

## Set score mythicstaffs.crafting.done to 0 if unfinished or 1 if finished
scoreboard players set MythicStaffs mythicstaffs.crafting.done 0
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:flint",components:{"minecraft:custom_model_data":1}}}] at @s if score MythicStaffs mythicstaffs.crafting.1 matches 1 if score MythicStaffs mythicstaffs.crafting.2 matches 1 if score MythicStaffs mythicstaffs.crafting.3 matches 1 run scoreboard players set MythicStaffs mythicstaffs.crafting.done 1

## Reset crafting cooldown
execute if score MythicStaffs mythicstaffs.crafting.done matches 0 run scoreboard players set MythicStaffs mythicstaffs.crafting.countdown 0
execute if score MythicStaffs mythicstaffs.crafting.done matches 1 run scoreboard players add MythicStaffs mythicstaffs.crafting.countdown 1

## Particles
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:flint",components:{"minecraft:custom_model_data":1}}}] at @s if score MythicStaffs mythicstaffs.crafting.done matches 1 run particle minecraft:enchanted_hit ~ ~ ~ 0.3 0.3 0.3 0.1 1

## Done crafting
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:flint",components:{"minecraft:custom_model_data":1}}}] at @s if score MythicStaffs mythicstaffs.crafting.countdown matches 30 run particle minecraft:sonic_boom ~ ~ ~ 0.3 0.3 0.3 0.1 10
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:flint",components:{"minecraft:custom_model_data":1}}}] at @s if score MythicStaffs mythicstaffs.crafting.countdown matches 30 run playsound minecraft:entity.warden.sonic_boom ambient @a ~ ~ ~
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:flint",components:{"minecraft:custom_model_data":1}}}] at @s if score MythicStaffs mythicstaffs.crafting.countdown matches 30 run summon item ~ ~ ~ {Item:{id:"minecraft:warped_fungus_on_a_stick",count:1,components:{"minecraft:custom_model_data":3,"minecraft:item_name":'{"italic":false,"text":"Empty Staff"}'}}}
execute as @e[type=item,tag=ready,nbt={Item:{id:"minecraft:flint",components:{"minecraft:custom_model_data":1}}}] at @s if score MythicStaffs mythicstaffs.crafting.countdown matches 30 run kill @e[type=item,tag=ready,distance=..1,nbt=!{Item:{id:"minecraft:warped_fungus_on_a_stick"}}]